unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Grids, DBGrids, Db, SQLServer, DBCtrls, ExtCtrls, ComCtrls,
  StdCtrls, Dialogs;
                             
type
  TForm1 = class(TForm) 
    SQLServer1: TSQLServer;
    SQLQuery1: TSQLQuery;
    DataSource1: TDataSource;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    StatusBar1: TStatusBar;
    SQLUpdate1: TSQLUpdate;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SQLQuery1PostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
  private
    procedure IdleHandler(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
     with SQLServer1 do begin
          UserName := 'guest';
          ServerName := 'THOMAS';
          Password := '';
     end;
     SQLQuery1.Open;
     Application.OnIdle := IdleHandler;
end;

procedure TForm1.IdleHandler(Sender: TObject; var Done: Boolean);
begin
     SQLQuery1.ReadAhead;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
     SQLServer1.StartTransaction;
     Button1.Enabled := False;
     Button2.Enabled := True;
     Button3.Enabled := True;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
     SQLQuery1.Locate('Company',Edit1.text,[loCaseInsensitive, loPartialKey]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     SQLServer1.Commit;
     Button1.Enabled := True;
     Button2.Enabled := False;
     Button3.Enabled := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     SQLServer1.RollBack;
     Button4Click(Sender);
     Button1.Enabled := True;
     Button2.Enabled := False;
     Button3.Enabled := False;
end;

procedure TForm1.Button4Click(Sender: TObject);
var Temp : TBookMark;
begin
     with SQLQuery1 do begin
          Temp := GetBookMark;
          DisableControls;
          Close;
          Open;
          EnableControls;
          GotoBookMark(Temp);
          FreeBookMark(Temp);
     end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caFree;
end;

procedure TForm1.SQLQuery1PostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin   
     if ESQLError(E).ErrorCode=2601 then begin
        ShowMessage('Another customer already assigned to this customer number');
        Action := daAbort;  
     end;
end;            

end.
